----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date: 03/26/2023 05:55:02 PM
-- Design Name: 
-- Module Name: test_process - Behavioral
-- Project Name: 
-- Target Devices: 
-- Tool Versions: 
-- Description: 
-- 
-- Dependencies: 
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
-- 
----------------------------------------------------------------------------------


library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx leaf cells in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity test_process is
Port ( 
a:  in  std_logic_vector(2 downto 0);
b:  in  std_logic_vector(2 downto 0);
c:  out std_logic_vector(5 downto 0)
);
end test_process;

architecture Behavioral of test_process is

signal temp:  std_logic_vector(2 downto 0):="XXX";
signal temp1: std_logic_vector(2 downto 0):="111";
signal test_int: integer:=0;

begin

-- This is what you need to know: Part A and Part B

-- Part A1 
--c<=a & b;     --Just concatenate 

-- Part A2 
--c<=temp & temp1;     --Just concatenate 

-- Part A3    --Equivalent to PartA1

--test: process (a,b) is
--begin
--test_int<=test_int+1;   --Process has been executed at least once
--c<=a&b;
--end process test;

-- Part A4      --Equivalent to PartA3

--test: process  is
--begin
--c<=a&b;
--test_int<=test_int+1;   --Process has been executed once
--wait on a,b;
--end process test;


-- Part B1                --Wrong results in Behavioral Simulation/ Right Result in Post Synthesis Timing Simulation

--test: process is        --No sensitivity list. It is called just one time. Executes for ever.

--begin

--test_int<=test_int+1;   --Process has been executed once
--c<=a & b;         
--wait;                   --if no wait statement then repeats for ever. Simulation in a permanent loop.
--                        --In Synthesis everything is fine
 
--end process test;

-- Part B2-1                                 
--test: process (a,b) is              
--begin                               

--test_int<=test_int+1;   --Test is one step behind                                         
--c<=temp & b;            --X at RTL, 0 at synthesis
    
--end process test;

---- Part B2-2                          
--test: process (a,b) is              
--begin                               

--test_int<=test_int+1;     
--temp<=a;                --Temp is one step behind                             
--c<=temp & b;            --U at RTL, Synthesis is OK                            
    
--end process test;

-- Part B2-3                          
--test: process (a,b, temp) is              
--begin                               

--test_int<=test_int+1;     
--temp<=a;                --Temp is one step behind                             
--c<=temp & b;            --Rest is fine                            
    
--end process test;

-- Part B3                          
test: process (a,b) is         
variable temp_var :  std_logic_vector(2 downto 0);    
begin                               

test_int<=test_int+1;    
temp_var:=a;               --Temp_var is OK                               
c<=temp_var & b;                                        
    
end process test;


--Part B4
--test: process  is         --Process freezes on wait, as temp never changes value
--begin
--c<=a&b;
--test_int<=test_int+1;     --Process has been executed once
--wait on temp;
--end process test;

end Behavioral;
